/**********************************************************************/
/** Copyright (C) 2021 - Université Catholique de Louvain		**/
/** affinistan version 2021.1						**/
/** Author: Mohamed HADDAD (immc-MEMA)				**/
/** Contact: mohamed.haddad@uclouvain.be				**/
/** Use of this source code is governed by an UCL-style license	**/ 
/** All Rights Reserved						**/
/** This project has received funding from the European 		**/
/** Union’s Horizon 2020 research and innovation program		**/
/** under grant agreement No 862015					**/
/***********************************************************************/

#ifndef STATE_H
#define STATE_H

typedef struct State {
  double *strn;  	/** Strain tensor 									**/
  double *strs;  	/** Stress tensor 									**/
  double p;      	/** Accumulated plasticity - scalar 							**/
  double *instrnrate;  /** Previously: double *g; - Inelastic strain rate tensor 				**/
  double **intgexp; 	/** Previously: double **int1; - Integral of g*exp(-st) - nbrcolloc*6 matrix 	**/
  double **intstrsexp; /** Previously: double **int2; - Integral of strs*exp(-st) - nbrcolloc*6 matrix 	**/
  double *pstrn;  	/** Plastic strain 									**/
  double **Si;        	/** Viscous deviatoric stress relative to every Gi					**/
  double **Sigma_Hj;  	/** Viscous volumetric stress relative to every Kj					**/
} STATE;

typedef struct Statemacro {
  double *strn;        /** Macroscopic strain tensor								**/
  double *strs;        /** Macroscopic stress tensor 							**/
  double *eigenstrn;   /** Macroscopic eigenstrain tensor 							**/
  double *intstrn;     /** integral over the time of the strain tensor 					**/
  double **intstrnexp; /** Previously: double **intstrnexpo; - Integral up to t=tf of strn(u)*exp(-(tf-u)*s[k])du - nbrcolloc*6 matrix **/
} STATEMACRO;


#endif
